
CREATE TABLE practices
(
	practice_id INTEGER  NOT NULL IDENTITY ,
	name VARCHAR (150) NOT NULL,
	description VARCHAR (600) NULL,
	is_active VARCHAR (15) NULL,
	
		CONSTRAINT pk_practices PRIMARY KEY
		(
		practice_id
		)
	
);
	
CREATE TABLE projects
(
	project_id INTEGER  NOT NULL IDENTITY ,
	name VARCHAR (150) NOT NULL,
	description VARCHAR (600) NULL,
	start_date DATETIME  NOT NULL,
	end_date DATETIME  NULL,
	
		CONSTRAINT pk_projects PRIMARY KEY
		(
		project_id
		)
	
);
	
CREATE TABLE project_plans
(
	project_plan_id INTEGER  NOT NULL IDENTITY ,
	project_id INTEGER  NOT NULL,
	
		CONSTRAINT pk_project_plans PRIMARY KEY
		(
		project_plan_id
		)
	
);
	
CREATE TABLE releases
(
	release_id INTEGER  NOT NULL IDENTITY ,
	name VARCHAR (150) NOT NULL,
	goal VARCHAR (500) NULL,
	project_plan_id INTEGER  NOT NULL,
	start_date DATETIME  NULL,
	finish_date DATETIME  NULL,
	
		CONSTRAINT pk_releases PRIMARY KEY
		(
		release_id
		)
	
);
	
CREATE TABLE iterations
(
	iteration_id INTEGER  NOT NULL IDENTITY ,
	name VARCHAR (150) NOT NULL,
	description VARCHAR (500) NULL,
	velocity DECIMAL  NULL,
	start_date DATETIME  NULL,
	release_id INTEGER  NOT NULL,
	duration INTEGER  NULL,
	
		CONSTRAINT pk_iterations PRIMARY KEY
		(
		iteration_id
		)
	
);
	
CREATE TABLE user_stories
(
	user_story_id INTEGER  NOT NULL IDENTITY ,
	name VARCHAR (250) NOT NULL,
	description VARCHAR (2500) NULL,
	effort DECIMAL  NOT NULL,
	status INTEGER  NOT NULL,
	project_plan_id INTEGER  NOT NULL,
	iteration_id INTEGER  NOT NULL,
	business_value_id INTEGER  NOT NULL,
	risk_id INTEGER  NOT NULL,
	user_id INTEGER  NULL,
	created_date DATETIME  NULL,
	completed_date DATETIME  NULL,
	
		CONSTRAINT pk_user_stories PRIMARY KEY
		(
		user_story_id
		)
	
);
	
CREATE TABLE business_value
(
	business_value_id INTEGER  NOT NULL IDENTITY ,
	value VARCHAR (25) NOT NULL,
	
		CONSTRAINT pk_business_value PRIMARY KEY
		(
		business_value_id
		)
	
);
	
CREATE TABLE risk
(
	risk_id INTEGER  NOT NULL IDENTITY ,
	value VARCHAR (25) NOT NULL,
	
		CONSTRAINT pk_risk PRIMARY KEY
		(
		risk_id
		)
	
);
	
CREATE TABLE team
(
	user_id INTEGER  NOT NULL,
	project_id INTEGER  NOT NULL,
	
		CONSTRAINT pk_team PRIMARY KEY
		(
		user_id,project_id
		)
	
);
	
CREATE TABLE users
(
	user_id INTEGER  NOT NULL IDENTITY ,
	name VARCHAR (150) NOT NULL,
	surname VARCHAR (150) NOT NULL,
	email VARCHAR (150) NULL,
	login VARCHAR (50) NOT NULL,
	password VARCHAR (50) NOT NULL,
	
		CONSTRAINT pk_users PRIMARY KEY
		(
		user_id
		)
	
);
	
ALTER TABLE releases

		ADD CONSTRAINT fk_releases_ProjectPlan FOREIGN KEY
		(
		project_plan_id
		)
		REFERENCES project_plans
		(
		project_plan_id		
		)
 ON DELETE CASCADE 
;
		
ALTER TABLE iterations

		ADD CONSTRAINT fk_iterations_Release FOREIGN KEY
		(
		release_id
		)
		REFERENCES releases
		(
		release_id		
		)
 ON DELETE CASCADE 
;
		
ALTER TABLE user_stories

		ADD CONSTRAINT fk_user_stories_ProjectPlan FOREIGN KEY
		(
		project_plan_id
		)
		REFERENCES project_plans
		(
		project_plan_id		
		)
 ON DELETE CASCADE 
;
		
ALTER TABLE team

		ADD CONSTRAINT fk_team_Project FOREIGN KEY
		(
		project_id
		)
		REFERENCES projects
		(
		project_id		
		)
 ON DELETE CASCADE 
;
		
ALTER TABLE team

		ADD CONSTRAINT fk_team_User FOREIGN KEY
		(
		user_id
		)
		REFERENCES users
		(
		user_id		
		)
 ON DELETE CASCADE 
;
		